GG: GG::Scroll Class Reference

GG

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | List of all members
GG::Scroll Class Reference

`#include <Scroll.h>`

Inheritance diagram for GG::Scroll:

## Public Types
enum | ScrollRegion

## Signal Types
typedef boost::signal< void(int, int, int, int)> | ScrolledSignalType
typedef boost::signal< void(int, int, int, int)> | ScrolledAndStoppedSignalType

## Structors
| Scroll (X x, Y y, X w, Y h, Orientation orientation, Clr color, Clr interior, Flags< WndFlag > flags=INTERACTIVE|REPEAT_BUTTON_DOWN)
| Scroll ()

## Accessors
ScrolledSignalType | ScrolledSignal
ScrolledAndStoppedSignalType | ScrolledAndStoppedSignal
virtual Pt | MinUsableSize () const
std::pair< int, int > | PosnRange () const
std::pair< int, int > | ScrollRange () const
unsigned int | LineSize () const
unsigned int | PageSize () const
Clr | InteriorColor () const
Orientation | ScrollOrientation () const
unsigned int | TabSpace () const
unsigned int | TabWidth () const
ScrollRegion | RegionUnder (const Pt &pt)
Button * | TabButton () const
Button * | IncrButton () const
Button * | DecrButton () const

## Mutators
virtual void | Render ()
virtual void | SizeMove (const Pt &ul, const Pt &lr)
virtual void | Disable (bool b=true)
virtual void | SetColor (Clr c)
void | SetInteriorColor (Clr c)
void | SizeScroll (int min, int max, unsigned int line, unsigned int page)
void | SetMax (int max)
void | SetMin (int min)
void | SetLineSize (unsigned int line)
void | SetPageSize (unsigned int page)
void | ScrollTo (int p)
void | ScrollLineIncr ()
void | ScrollLineDecr ()
void | ScrollPageIncr ()
void | ScrollPageDecr ()
virtual void | LButtonDown (const Pt &pt, Flags< ModKey > mod_keys)
virtual void | LButtonUp (const Pt &pt, Flags< ModKey > mod_keys)
virtual void | LClick (const Pt &pt, Flags< ModKey > mod_keys)
virtual void | MouseHere (const Pt &pt, Flags< ModKey > mod_keys)
virtual bool | EventFilter (Wnd *w, const WndEvent &event)

## Additional Inherited Members
Public Member Functions inherited from GG::Control
virtual void | DropsAcceptable (DropsAcceptableIter first, DropsAcceptableIter last, const Pt &pt) const
Clr | Color () const
bool | Disabled () const
virtual void | AcceptDrops (const std::vector< Wnd * > &wnds, const Pt &pt)
Public Member Functions inherited from GG::Wnd
virtual | ~Wnd ()
bool | Interactive () const
bool | RepeatButtonDown () const
bool | Dragable () const
bool | Resizable () const
bool | OnTop () const
bool | Modal () const
ChildClippingMode | GetChildClippingMode () const
bool | NonClientChild () const
bool | Visible () const
const std::string & | Name () const
const std::string & | DragDropDataType () const
Pt | UpperLeft () const
Pt | LowerRight () const
Pt | RelativeUpperLeft () const
Pt | RelativeLowerRight () const
X | Width () const
Y | Height () const
int | ZOrder () const
Pt | Size () const
Pt | MinSize () const
Pt | MaxSize () const
virtual Pt | ClientUpperLeft () const
virtual Pt | ClientLowerRight () const
Pt | ClientSize () const
X | ClientWidth () const
Y | ClientHeight () const
Pt | ScreenToWindow (const Pt &pt) const
Pt | ScreenToClient (const Pt &pt) const
virtual bool | InWindow (const Pt &pt) const
virtual bool | InClient (const Pt &pt) const
const std::list< Wnd * > & | Children () const
Wnd * | Parent () const
Wnd * | RootParent () const
Layout * | GetLayout () const
Layout * | ContainingLayout () const
const std::vector < BrowseInfoMode > & | BrowseModes () const
const std::string & | BrowseInfoText (std::size_t mode) const
const boost::shared_ptr < StyleFactory > & | GetStyleFactory () const
virtual WndRegion | WindowRegion (const Pt &pt) const
void | SetDragDropDataType (const std::string &data_type)
virtual void | StartingChildDragDrop (const Wnd *wnd, const Pt &offset)
virtual void | CancellingChildDragDrop (const std::vector< const Wnd * > &wnds)
virtual void | ChildrenDraggedAway (const std::vector< Wnd * > &wnds, const Wnd *destination)
void | SetName (const std::string &name)
void | Hide (bool children=true)
void | Show (bool children=true)
virtual void | ModalInit ()
void | SetChildClippingMode (ChildClippingMode mode)
void | NonClientChild (bool b)
void | MoveTo (const Pt &pt)
void | OffsetMove (const Pt &pt)
void | Resize (const Pt &sz)
void | SetMinSize (const Pt &sz)
void | SetMaxSize (const Pt &sz)
void | AttachChild (Wnd *wnd)
void | MoveChildUp (Wnd *wnd)
void | MoveChildDown (Wnd *wnd)
void | DetachChild (Wnd *wnd)
void | DetachChildren ()
void | DeleteChild (Wnd *wnd)
void | DeleteChildren ()
void | InstallEventFilter (Wnd *wnd)
void | RemoveEventFilter (Wnd *wnd)
void | HorizontalLayout ()
void | VerticalLayout ()
void | GridLayout ()
void | SetLayout (Layout *layout)
void | RemoveLayout ()
Layout * | DetachLayout ()
void | SetLayoutBorderMargin (unsigned int margin)
void | SetLayoutCellMargin (unsigned int margin)
virtual bool | Run ()
void | EndRun ()
void | SetBrowseModeTime (unsigned int time, std::size_t mode=0)
void | SetBrowseInfoWnd (const boost::shared_ptr< BrowseInfoWnd > &wnd, std::size_t mode=0)
void | ClearBrowseInfoWnd (std::size_t mode=0)
void | SetBrowseText (const std::string &text, std::size_t mode=0)
void | SetBrowseModes (const std::vector< BrowseInfoMode > &modes)
void | SetStyleFactory (const boost::shared_ptr< StyleFactory > &factory)
| GG_ABSTRACT_EXCEPTION (Exception)
| GG_CONCRETE_EXCEPTION (BadLayout, GG::Wnd, Exception)
Static Public Member Functions inherited from GG::Wnd
static unsigned int | DefaultBrowseTime ()
static void | SetDefaultBrowseTime (unsigned int time)
static const boost::shared_ptr < BrowseInfoWnd > & | DefaultBrowseInfoWnd ()
static void | SetDefaultBrowseInfoWnd (const boost::shared_ptr< BrowseInfoWnd > &browse_info_wnd)
Protected Types inherited from GG::Wnd
enum | DragDropRenderingState { NOT_DRAGGED, IN_PLACE_COPY, DRAGGED_OVER_UNACCEPTING_DROP_TARGET, DRAGGED_OVER_ACCEPTING_DROP_TARGET }
Protected Member Functions inherited from GG::Control
virtual void | MouseWheel (const Pt &pt, int move, Flags< ModKey > mod_keys)
virtual void | KeyPress (Key key, boost::uint32_t key_code_point, Flags< ModKey > mod_keys)
virtual void | KeyRelease (Key key, boost::uint32_t key_code_point, Flags< ModKey > mod_keys)
| Control ()
| Control (X x, Y y, X w, Y h, Flags< WndFlag > flags=INTERACTIVE)
Protected Attributes inherited from GG::Control
Clr | m_color
bool | m_disabled

## Detailed Description

This is a basic scrollbar control.

The range of the values the scrollbar represents is [m_range_min, m_range_max]. However, m_posn can only range over [m_range_min, m_range_max - m_page_sz], because the tab has a logical width of m_page_sz. So the region of the scrollbar's range being viewed at any one time is [m_posn, m_posn + m_page_sz]. (m_posn + m_page_sz is actually the last + 1 element of the range.) The parent of the control is notified of a scroll via ScrolledSignalType signals; these are emitted from the Scroll*() functions and the UpdatePosn() function. This should cover every instance in which m_posn is altered. The parent can poll the control to get its current view area with a call to GetPosnRange(). An increase in a vertical scroll is down, and a decrease is up; since GG assumes the y-coordinates are downwardly increasing. The rather plain default buttons and tab can be replaced by any Button-derived controls desired.

Definition at line 54 of file Scroll.h.

## Constructor & Destructor Documentation

GG::Scroll::Scroll | ( | X | x,
|  | Y | y,
|  | X | w,
|  | Y | h,
|  | Orientation | orientation,
|  | Clr | color,
|  | Clr | interior,
|  | Flags< WndFlag > | flags = `INTERACTIVE|REPEAT_BUTTON_DOWN`
| ) |  |

Ctor.

## Member Function Documentation

virtual Pt GG::Scroll::MinUsableSize | ( |  | ) | const
| virtual

Returns the size of the minimum bounding box that can enclose the Wnd and still show all of its elements, plus enough room for interaction with those elements (if applicable). For example, a TextControl's MinUsableSize() is just the area of its text, and a Scroll's MinUsableSize() is the combined sizes of its up-button, down-button, and tab (plus a bit of room in which to drag the tab).

Reimplemented from GG::Wnd.

virtual void GG::Scroll::Render | ( |  | ) |
| virtual

Draws this Wnd. Note that Wnds being dragged for a drag-and-drop operation are rendered twice – once in-place as normal, once in the location of the drag operation, attached to the cursor. Such Wnds may wish to render themselves differently in those two cases. To determine which render is being performed, they can call GUI::GetGUI()->RenderingDragDropWnds().

Implements GG::Control.

virtual void GG::Scroll::SizeMove | ( | const Pt & | ul,
|  | const Pt & | lr
| ) |  |
| virtual

Resizes and/or moves window to new upper-left and lower right boundaries.

Reimplemented from GG::Wnd.

virtual void GG::Scroll::LButtonDown | ( | const Pt & | pt,
|  | Flags< ModKey > | mod_keys
| ) |  |
| protectedvirtual

Respond to left button down msg. A window receives this whenever any input device button changes from up to down while over the window.

Note
  If this Wnd was created with the REPEAT_BUTTON_DOWN flag, this method may be called multiple times during a single button press-release cycle.

See Also
  GG::GUI

Reimplemented from GG::Wnd.

virtual void GG::Scroll::LButtonUp | ( | const Pt & | pt,
|  | Flags< ModKey > | mod_keys
| ) |  |
| protectedvirtual

Respond to release of left mouse button outside this Wnd, if it was originally depressed over this Wnd. A Wnd will receive an LButtonUp() message whenever a drag that started over its area ends, even if the cursor is not currently over the window when this happens.

Reimplemented from GG::Wnd.

virtual void GG::Scroll::LClick | ( | const Pt & | pt,
|  | Flags< ModKey > | mod_keys
| ) |  |
| protectedvirtual

Respond to release of left mouse button over this Wnd, if it was also originally depressed over this Wnd. A Wnd will receive an LButtonUp() message whenever a drag that started over its area ends over its area as well.

Reimplemented from GG::Wnd.

virtual void GG::Scroll::MouseHere | ( | const Pt & | pt,
|  | Flags< ModKey > | mod_keys
| ) |  |
| protectedvirtual

Respond to cursor moving about within the Wnd, or to cursor lingering within the Wnd for a long period of time. A MouseHere() message will not be generated the first time the cursor enters the window's area. In that case, a MouseEnter() message is generated.

Reimplemented from GG::Wnd.

virtual bool GG::Scroll::EventFilter | ( | Wnd * | w,
|  | const WndEvent & | event
| ) |  |
| protectedvirtual

Handles an WndEvent destined for Wnd w, but which this Wnd is allowed to handle first. Returns true if this filter processed the message.

Reimplemented from GG::Wnd.

The documentation for this class was generated from the following file:

- Scroll.h